#include <libwccl/lexicon/lexiconparser.h>
#include "ANTLRLexiconParser.hpp"
#include "ANTLRLexiconLexer.hpp"

#include <libwccl/lexicon/lexicon.h>
#include <libwccl/exception.h>

#include <fstream>

namespace Wccl {

boost::shared_ptr<Lexicon> LexiconParser::parse_lexicon(
	const PwrNlp::PathSearcherBase& search_path,
	const std::string& lexicon_name,
	const std::string& filename)
{
	std::ifstream is;
	search_path.open_stream_or_throw(filename, is, "lexicon");
	if (!is.good()) {
		throw Wccl::FileNotFound(filename, "", __FUNCTION__);
	}

	ANTLRLexiconLexer lexer(is);
	ANTLRLexiconParser parser(lexer);
	return parser.parse_lexicon_file(lexicon_name);
}

} /* end ns Wccl */
